module Hval
  class Schema
    include Hval::Validators
    
    def initialize(schema)
      @validators = schema.collect do |op, spec|
        method("validate_#{op}").call(spec)
      end
    end
    
    def validators
      @validators
    end
    
    def call(value)
      @validators.collect do |validator|
        validator.call(value)
      end
    end
    
    def match?(value)
      Hval::Result.new(self.call(value)).success?
    end
    
  end  
end